#include <iostream>
#include <cmath>
#include <fstream>
#include "../kdm2/header.h"

#define MAX_ITERATIONS 1000

void jacobi(float **Ao, float *b, int n, float EPSILON) {
    int i, j, k;
    float *new_x = new float[n];
    float **A=new float*[n];
    float x[n];
    for (char a=0;a<n;a++){A[a]=new float[n];for(char b=0;b<n;b++)A[a][b]=Ao[a][b];x[a]=b[a]/A[a][a];}
    float sum;
    for (k = 0; k < MAX_ITERATIONS; k++) {
        for (i = 0; i < n; i++) {
            sum = 0.0;
            for (j = 0; j < n; j++) {
                if (j != i) {
                    sum += A[i][j] * x[j];
                }
            }
            new_x[i] = (b[i] - sum) / A[i][i];
        }
        float error = 0.0;
        for (i = 0; i < n; i++) {
            error += abs(new_x[i] - x[i]);
            x[i] = new_x[i];
        }
        
        cout<<"Ітерація №"<<k + 1<<':'<<endl;
        for (i = 0; i < n; i++)cout<<"x"<<i+1<<" = "<<x[i]<<endl;
        cout<<endl;
        
        if (error < EPSILON) {
            cout<<"Метод простої ітерації зайняв "<<k + 1<<" ітерацій"<<endl;
            break;
        }
    }
    
    if (k == MAX_ITERATIONS)
        cout<<"Ітераційний процес перевищив допустимий ліміт ітерацій."<<endl;
    
    delete[] new_x;
}

void gauss_seidel(float **A, float *b, int n, float EPSILON) {
    int i, j, k;
    float sum;
    float *x;
    for (char a=0;a<n;a++)x[a]=b[a];
    for (k = 0; k < MAX_ITERATIONS; k++) {
        float *prev_x = new float[n]; // Зберігаємо попереднє наближення
        for (i = 0; i < n; i++) {
            prev_x[i] = x[i];
        }
        
        for (i = 0; i < n; i++) {
            sum = 0.0;
            for (j = 0; j < n; j++) {
                if (j != i) {
                    sum += A[i][j] * x[j];
                }
            }
            x[i] = (b[i] - sum) / A[i][i];
        }
        
        cout<<"Ітерація №"<<k + 1<<':'<<endl;
        for (i = 0; i < n; i++)
            for (i = 0; i < n; i++)cout<<"x"<<i+1<<" = "<<x[i]<<endl;
            cout<<endl;
        
        // Перевірка відносної помилки
        float relative_error = 0.0;
        for (i = 0; i < n; i++)
            relative_error += abs((x[i] - prev_x[i]) / x[i]);
        
        if (relative_error < EPSILON) {
            cout<<"Метод Зейделя зайняв "<<k+1<<" ітерацій"<<endl;
            break;
        }
        
        delete[] prev_x;
    }
    
    if (k == MAX_ITERATIONS) {
        printf("Перевищено ліміт ітерацій.\n");
    }
}



int main() {
    std::ifstream file;
    file.open("input");
    if (!file.is_open()) {
        printf("Помилка при відкритті файлу.\n");
        return 1;
    }
    
    int n;
    file>>n;
    
    float **A = new float*[n];
    float *b = new float[n];
    float *x1 = new float[n];
    
    int i, j;
    for (i = 0; i < n; i++) {
        A[i] = new float[n];
        for (j = 0; j < n; j++) {
            file>>A[i][j];
        }
        file>>b[i];
    }
    display(A,n,2,"SLE:");
    
    file.close();
    std::string input;
    cout<<"Enter epsylon, like 0.01"<<endl;cin>>input;
    float e=stof(input);
    cout<<std::setprecision(-log10(e)+1);
    
    cout<<"Метод Якобі:"<<endl;
    jacobi(A, b, n,e);
    
    cout<<"Метод Зейделя:"<<endl;
    gauss_seidel(A, b, n, e);
    
    for (i = 0; i < n; i++)
        delete[] A[i];
    delete[] A;
    delete[] b;
    
    return 0;
}
